/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2024  SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.velocitycore.commands;

import com.velocitypowered.api.proxy.Player;
import com.velocitypowered.api.proxy.server.RegisteredServer;
import com.velocitypowered.api.proxy.server.ServerInfo;
import de.steamwar.command.PreviousArguments;
import de.steamwar.command.SWCommand;
import de.steamwar.command.TypeMapper;
import de.steamwar.messages.Chatter;
import de.steamwar.persistent.Subserver;
import de.steamwar.sql.SteamwarUser;
import de.steamwar.sql.UserPerm;
import de.steamwar.velocitycore.VelocityCore;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class SendCommand extends SWCommand {

    public SendCommand() {
        super("send", UserPerm.TEAM);
    }

    @Register
    public void sendToServer(Chatter sender, Player send, RegisteredServer server) {
        send.createConnectionRequest(server).fireAndForget();
    }

    @ClassMapper(value = RegisteredServer.class, local = true)
    public TypeMapper<RegisteredServer> subserverTypeMapper() {
        return new TypeMapper<>() {
            private boolean check(SteamwarUser user, RegisteredServer registeredServer) {
                ServerInfo serverInfo = registeredServer.getServerInfo();
                String name = serverInfo.getName();
                if (name.contains(" ")) return false;

                Subserver subserver = Subserver.getSubserver(serverInfo);
                if (subserver == null) {
                    return true;
                }

                return switch (subserver.getType()) {
                    case ARENA -> true;
                    case BUILDER -> user.hasPerm(UserPerm.BUILD);
                    default -> false;
                };
            }

            @Override
            public RegisteredServer map(Chatter sender, PreviousArguments previousArguments, String s) {
                SteamwarUser user = sender.user();
                for (RegisteredServer registeredServer : VelocityCore.getProxy().getAllServers()) {
                    if (check(user, registeredServer)) {
                        return registeredServer;
                    }
                }
                return null;
            }

            @Override
            public Collection<String> tabCompletes(Chatter sender, PreviousArguments previousArguments, String s) {
                SteamwarUser user = sender.user();
                List<String> tabCompletes = new ArrayList<>();
                for (RegisteredServer registeredServer : VelocityCore.getProxy().getAllServers()) {
                    if (check(user, registeredServer)) {
                        tabCompletes.add(registeredServer.getServerInfo().getName());
                    }
                }
                return tabCompletes;
            }
        };
    }
}
